/*
	Copyright (c) 2003 Michael Carrato. All rights reserved.	

	Permission to use, modify, copy, and distribute this software 
	and its documentation is hereby granted without fee, 
	provided that the above copyright notice appears in all copies.
	This software is provided "as is" without express or implied 
    warranty.
*/

#include "TimeOfDay.h"

#include <assert.h>
#include <iostream>

#ifdef _TOD_USE_WINDOWS_TIME
#include <windows.h>


/*class TimeOfDayImpl
{
public:
    static void GetCurrent(TimeOfDayImpl& loc)
    {
        SYSTEMTIME timeVal;
        GetLocalTime(&timeVal);
        SystemTimeToFileTime(&timeVal,&loc.fileTime_);
    }
    TimeOfDayImpl()
    {
        timeVal_.wYear=0; 
        timeVal_.wMonth=0; 
        timeVal_.wDayOfWeek=0; 
        timeVal_.wDay=0; 
        timeVal_.wHour=0; 
        timeVal_.wMinute=0; 
        timeVal_.wSecond=0; 
        timeVal_.wMilliseconds=0; 
        fileTime_.dwLowDateTime = 0;
        fileTime_.dwHighDateTime = 0; 
    }
private:
    FILETIME fileTime_;
};*/

void TimeOfDayImpl__Win32::setToCurrentTime()
{
    SYSTEMTIME timeVal;
    GetLocalTime(&timeVal);
    assert(sizeof(TimeOfDayImpl__Win32) == sizeof(FILETIME));
    SystemTimeToFileTime(&timeVal,reinterpret_cast<FILETIME*>(this));
}

#endif

//static 
void TimeOfDay::DoTests()
{
    TimeOfDay tod;
    tod.setToCurrentTime();
    for(int i=0; i < 1000000; ++i)
    {
        TimeOfDay tod2;
        tod2.setToCurrentTime();
        TimeOfDay todDiff = tod2 - tod;
        std::cout << (unsigned long) todDiff.totalSeconds() << " seconds (" << (unsigned long) todDiff.totalMilliSeconds() << " milliseconds)                         \r";
    }
}    

