/*
	Copyright (c) 2003 Michael Carrato. All rights reserved.	

	Permission to use, modify, copy, and distribute this software 
	and its documentation is hereby granted without fee, 
	provided that the above copyright notice appears in all copies.
	This software is provided "as is" without express or implied 
    warranty.
*/

//disable annoying MSC warning about debug symbols
#ifdef _MSC_VER
#pragma warning (disable:4786)
#endif // _MSC_VER

void testSESet();
void testSEMap();
void TestMaximizeSpeedPolicy();

#include <iostream>
#include "CompactSet.h"
#include "TimeOfDay.h"

//typedef CompactSet<int,std::less<int>,MaximizeSpeedPolicy> CompactSetType;
typedef CompactSet<int,std::less<int>,MinimizeSpacePolicy> CompactSetType;
//typedef CompactSet<int,std::less<int>,MinimizeSpacePolicy> CompactSetType;
//typedef CompactSet<int> CompactSetType;
typedef CompactSet<int> SES2Type;
void CompactSetFindSpeedTest()
{
    std::set<int> control;
    CompactSetType sa;
    SES2Type sa2;
    int i;
    for(i=0;i<500000;++i)
    {
	if(i % 1000 == 0)
	{
		std::cout << i << "              \r" << std::flush;
	}
        unsigned newRand = (unsigned) (rand() * rand()) % 500000;
        if(rand() % 2)
        {
            control.insert(newRand);
            sa.insert(newRand);
        }
        else
        {
           control.erase(newRand);
           sa.erase(newRand);
        }
    }
    std::cout << "size=" << sa.size() << "(control size=" << control.size() << ")\n" << std::flush;
    sa.compact();
    TimeOfDay startTime;
    startTime.setToCurrentTime();
    for(i=0;i<5000000;++i)
    {
	if(i % 100000 == 0)
	{
        std::cout << i << "              \r" << std::flush;
	}
        unsigned newRand = (unsigned) (rand() * rand()) % 50000;
        control.find(newRand);
//        sa.find(newRand);
/*        CompactSetType::iterator found = sa.find(newRand);
        if(found != sa.end())
        {
            std::cout << "found: " << *found << ", key: " << newRand << "\n";
             assert(*found == newRand);
        }*/
    }
    TimeOfDay endTime;
    endTime.setToCurrentTime();
    std::cout << "Total find time: " << (unsigned long) (endTime-startTime).totalMilliSeconds() << "\n" << std::flush;
}


int main()
{
//    TestMaximizeSpeedPolicy();
    testSEMap();
    testSESet();
    CompactSetFindSpeedTest();
    return 0;
}
