#
# decodeld.sh - decode arguments to ld
#
# $Id: decodeld.sh,v 1.1.1.1 2003/05/18 22:48:30 jonm Exp $

DECLAREARRAY(ORIGCMDLINE,"$0" "$@")

while [ $# -gt 0 ]
do
	#
	# Make sure the any two-argument versions of an option appear
	# before a compont one, e.g. -I file before -Ifile as -I* will
	# match both inputs.
	#
	case "$1" in
		-D)	DEFS[${#DEFS[*]}]="-D$2"; shift;;
		-D*)DEFS[${#DEFS[*]}]="$1";;
		-L)	LPATHS[${#LPATHS[*]}]="-L$2"; shift;;
		-L*)LPATHS[${#LPATHS[*]}]="$1";;
		-R)	LPATHS[${#LPATHS[*]}]="-L$2"; shift;;
		-R*)LPATHS[${#LPATHS[*]}]="-L${1##-R}";;
		-U)	DEFS[${#DEFS[*]}]="-U$2"; shift;;
		-U*)DEFS[${#DEFS[*]}]="$1";;
		-l*)LIBS[${#LIBS[*]}]="$1";;
		-h) shift ;; # Throw away dynamic section name in following argument
		-h*) ;; # Throw away dynamic section name
		-G | -shared | -symbolic) DYNLIB=Y;;
		-o) TARGET="$2"; shift;;
		-o*)TARGET="${1##-o}";;
		*.c | *.C | *.cpp)
		    SRCS[${#SRCS[*]}]="$1";;
		*.o | *.obj | *.lo)
		    OBJS[${#OBJS[*]}]="$1";;
		*.a | *.lib)LIBS[${#LIBS[*]}]="$1";;
		*.so*)
		    LIBS[${#LIBS[*]}]="$1";;
    esac
    shift
done
