#
# housekeeping.sh - perform standard housekeeping duties for
# the wrapper scripts.  Supress execution as desired and remap
# stdout/stderr.
#
# $Id: housekeeping.sh,v 1.1.1.1 2003/05/18 22:48:30 jonm Exp $

#
# Environment variables
#
# LINTOFF override to prevent the lint wrapper from running lint
#         code.  Especially useful inside configuration scripts.
# LINTDBG output lint commands as they are run
# LINTLOG redirect output to lint directory.
# LINTCC - cc to call for lint
#

if test x"$LINTOFF" != x
then
	exit $REAL_RET
fi


#
# Detect autoconf generated configure script.  linting breaks configure
# so stop if detected.
#
INCONFIGURE=$( ( if echo -n '' >&6 ; \
                 then echo "Y" ; \
				 else echo "N" ; fi ) 2>/dev/null )

if test x"$INCONFIGURE" = xY
then
	exit $REAL_RET
fi

#
# If LINTLOG is set, redirect all output there
#
if test x"$LINTLOG" != x
then
	exec >> "$LINTLOG" 2>&1
fi
