#! @WRAPSHELL@
#
# Interpose the installer to install lint libraries.
#
# $Id: lintinstall.sh,v 1.1.1.1 2003/05/18 22:48:30 jonm Exp $
#

: ${LINTINSTALL:=@INSTALL@}
${LINTINSTALL} "$@"
REAL_RET=$?

### HOUSEKEEPING ###

remaplibs() {
	while (($# > 0))
	do
		remapped=$(echo $1 | sed -e 's!\.libs/!!g' -e 's/lib\([^\./][^\.]*\)\.a/llib-l\1.ln/g' -e 's/lib\([a-z0-9_\-][a-z0-9_\-]*\)\.so.*/llib-l\1-so.ln/g')
		echo \"$remapped\"
		shift
	done
}

#
# Check for libraries and if so, install the lint library version if present.
#
case "$@" in
	*.so* | *.a)
		# Remap all of the arguments
		eval set -- `remaplibs "$@"`

		${LINTINSTALL} "$@"
		;;
esac

exit $REAL_RET
