#
# Location of the lint binary
#
: ${LINT:=@LINT@}

#
# Lint object/library filenames
#
LINTOBJEXT=ln
LINTLIBPFX=llib-l
LINTLIBEXT=ln

#
# Standard lint paths
#
DECLAREARRAY(STDLPATHS,@LINTLIBPATH@)

#
# Lint library creation options.
#  LINTLIBTGT is the flag to create the lint library immediately preceding
#                the lint library name.
#  LINTLIBFLAGS are any flags to turn off error reporting for libraries.
#
: ${LINTLIBTGT:=@LINTLIBTGT@}
: ${LINTLIBFLAGS:=@LINTLIBFLAGS@}
: ${LINTCOMPILEFLAGS:=@LINTCOMPILEFLAGS@}
#
# Transforms for cc/ld -o target to lint library name
#
# For ksh/bash compatibility must define each element as the
# composite assignments (declare -a or set -A) are different between the
# two shells.
#
TGTXFORMS[0]="s!/\.libs/!/!g"
TGTXFORMS[1]="s!^\.libs/!!g"
TGTXFORMS[2]="s/\.so[\.0-9]*$/-so/"
TGTXFORMS[3]="s/^lib//g"

#
# Transforms for ar target to lint archive library name
#
ALNXFORMS[0]="s!/\.libs/!/!g"
ALNXFORMS[1]="s!^\.libs/!!g"
ALNXFORMS[2]="s!\.a\$!.aln!g"
ALNXFORMS[3]="s!\.al\$!.aln!g"

#
# Transforms from compiler objects to lint objects
#
OBJXFORMS[0]="s/\.lo$/-lo.ln/"
OBJXFORMS[1]="s/\.o$/.ln/g"
