#
# remapobjs.sh -  Unlibtoolize all of the object files and targets,
#                 then convert to lint object names.
#
#                 There are three main conversion scenarios
#                 1. In the current directory, do nothing.
#                 2. Being compiled into a .libs directory and
#                    moved back out using libtool.  In which case
#                    drop the .libs
#                 3. Being compiled into a .libs subdirectory as
#                    part of combining two libraries.  Libtool expands
#                    out all of the source files and recreates the library.
#                    The files are in .libs/libname.lax/filename.ln.
#                    Libtool calls AR to extract the files so the wrapper
#                    piggybacks it and expands the .ln files.  Make
#                    sure the paths are kept.
#
#
# $Id: remapobjs.sh,v 1.1.1.1 2003/05/18 22:48:30 jonm Exp $

i=0
while (($i < ${#OBJS[*]}))
do
	
	# If the last dir is .libs - remove it, otherwise keep it.
	b=`basename "${OBJS[$i]}"`
	d=`dirname "${OBJS[$i]}"`
	
	#echo "$i: [$d] [$b] ##[${d##*/}] %%[${d%%/*}] %[${d%/*}]"  
	
	if [ "${d}" = ".libs" ] # If .libs/file
	then
		OBJS[$i]="$b"
	elif [ "${d##*/}" = ".libs" ] # If anypath/.libs/file
	then
		OBJS[$i]="${d%/*}/$b"
	fi
	
	for xform in "${OBJXFORMS[@]}"
	do
		OBJS[$i]=$(echo "${OBJS[$i]}" | sed -e "$xform")
	done	
	
	i=$(($i+1))
done
