/* Copyright (C) Kwee Heong Tan 2002 - 2003
   Permission is granted to use this code without restriction as
   long as this copyright notice appears in all source files.
*/
// $Id: DLogic.hpp,v 1.5 2002/11/21 18:08:50 khtan Exp $
#include "DLogic.h"
#include "DLogic.cpp"
// DLogic*Functors, need .h and .cpp for template instantiation     
#include <functional>

template<typename T>
struct DLogicNotFunctor : std::unary_function<T,T>{
  const T& operator()(const T& rhs) const{
    return (! rhs);
  }
};
template<typename T>
struct DLogicAndFunctor : std::binary_function<T,T,T>{
  const T& operator()(const T& lhs,const T& rhs) const{
    return ( lhs && rhs );
  }
};
template<typename T>
struct DLogicOrFunctor : std::binary_function<T,T,T>{
  const T& operator()(const T& lhs, const T& rhs) const{
    return (lhs || rhs);
  }
};
